package MLDB_HASH;
use strict;
use DB_File;
use MLDBM qw(DB_File);
use Fcntl;

sub new {
   my $proto = shift;
   my $class = ref($proto) || $proto;
   my $self = {
       file    => shift,
       DBM     => {},
   };
   bless ($self,$class);
   return $self;
}

sub openr {
    my $self = shift;
    tie (%{$self->{DBM}}, 'MLDBM', $self->{file}, O_RDONLY, 0666, $DB_HASH) || die $!;
}

sub closer {
    my $self = shift;
    untie %{$self->{DBM}};
}

sub openw {
    my $self = shift;
    my $append = shift;
    if ($append) {
	tie (%{$self->{DBM}}, 'MLDBM', $self->{file}, O_RDWR|O_CREAT, 0666, $DB_HASH) || die $!;
    } else {
	tie (%{$self->{DBM}}, 'MLDBM', $self->{file}, O_RDWR|O_CREAT, 0666, $DB_HASH) || die $!;
    }
}

sub closew {
    my $self = shift;
    untie %{$self->{DBM}};
}

sub exists {
    my $self = shift;
    my $entry = shift;
    return 1 if (exists ($self->{DBM}{$entry}));
    return 0;
}

sub get_files {
    my $self = shift;
    my @keys = keys %{$self->{DBM}};
    for (@keys) { print "_ is \'$_\'\n"; }
    return @keys;
}

sub get_entry {
    my $self = shift;
    my $entry = shift;
    return $self->{DBM}{$entry};
}

sub write {
    my $self = shift;
    my $entry = shift;
    my $hashref = shift;
    #my $title = shift;
    #my $key = shift;
    #my $desc = shift;
    #my $body = shift;
    #my $hashref = {'title' => $title, 'key' => $key, 'desc' => $desc, 'body' => $body};
    $self->{DBM}{$entry} = $hashref;
}
1;


